PvPTimer = LibStub("AceAddon-3.0"):NewAddon("PvPTimer", "AceConsole-3.0", "AceEvent-3.0")

local addon = PvPTimer
addon.Locale = LibStub:GetLibrary("AceLocale-3.0"):GetLocale("PvPTimer")
addon.Const = {}
addon.Spells = {}
addon.SpecSpells = {}

CreateFrame("GameTooltip", "PT_Tooltip", UIParent, "GameTooltipTemplate")
PT_Tooltip:SetClampedToScreen(true)
PT_Tooltip:Hide()

local tsort = table.sort

-- default settings
addon.Defaults = {
	global = {
		build = 0,
		spells = {},
		anchor_default = {
			["Enabled"] = true,
			["Locked"] = true,
			["Else"] = true,
			["Scale"] = 1.0,
			["BG"] = true,
			["RatedBG"] = true,
			["Width"] = 150,
			["Header"] = {
				["Show"] = true,
				["ClassColor"] = true,
				["Font"] = "Arial Narrow",
				["FontSize"] = 14,
				["Justify"] = "CENTER",
				["Color"] = {
					["a"] = 0.7,
					["b"] = 0.5,
					["g"] = 0.3,
					["r"] = 0.2,
				},
				["ShowSpec"] = true,
				["ShowClass"] = true,
				["Texture"] = "Blizzard",
			},
			["Position"] = {
				["AttachFrame"] = "UIParent",
				["AttachRelative"] = "CENTER",
				["AttachX"] = "0",
				["AttachPoint"] = "CENTER",
				["AttachY"] = "-100",
			},
			["Bars"] = {
				["NameFont"] = "Arial Narrow",
				["Columns"] = 3,
				["Color"] = {
					["a"] = 0.7,
					["b"] = 0.5,
					["g"] = 0.3,
					["r"] = 0.2,
				},
				["TimeFont"] = "Arial Narrow",
				["TimeFontSize"] = 10,
				["GrowUp"] = false,
				["NameFontSize"] = 10,
				["ShowName"] = false,
				["ShowTime"] = true,
				["TypeColor"] = true,
				["Texture"] = "Charcoal",
			},
			["Autohide"] = "notarget",
			["Arena"] = true,
		},
	},
	profile = {
		Settings = {
			EnableAddon = true,
		},
		Spells = {},
		Anchors = {
			Anchor_Target = {
				Width = 150,
				Position = {
					["AttachFrame"] = "UIParent",
					["AttachRelative"] = "TOPLEFT",
					["AttachX"] = "200",
					["AttachPoint"] = "TOPLEFT",
					["AttachY"] = "-150",
				},
				["Header"] = {
					["Show"] = true,
					["ClassColor"] = true,
					["Font"] = "Arial Narrow",
					["FontSize"] = 14,
					["Justify"] = "CENTER",
					["Color"] = {
						["a"] = 0.7,
						["b"] = 0.5,
						["g"] = 0.3,
						["r"] = 0.2,
					},
					["ShowSpec"] = true,
					["ShowClass"] = true,
					["Texture"] = "Blizzard",
				},
			},
			Anchor_Focus = {
				Width = 150,
				Position = {
					["AttachFrame"] = "UIParent",
					["AttachRelative"] = "TOPLEFT",
					["AttachX"] = "200",
					["AttachPoint"] = "TOPLEFT",
					["AttachY"] = "-250",
				},
				["Header"] = {
					["Show"] = true,
					["ClassColor"] = true,
					["Font"] = "Arial Narrow",
					["FontSize"] = 14,
					["Justify"] = "CENTER",
					["Color"] = {
						["a"] = 0.7,
						["b"] = 0.5,
						["g"] = 0.3,
						["r"] = 0.2,
					},
					["ShowSpec"] = true,
					["ShowClass"] = true,
					["Texture"] = "Blizzard",
				},
			},
			Anchor_Arena = {
				Width = 120,
				Position = {
					["AttachFrame"] = "UIParent",
					["AttachRelative"] = "TOPLEFT",
					["AttachX"] = "270",
					["AttachPoint"] = "TOPLEFT",
					["AttachY"] = "-25",
					["NextX"] = 140,
					["NextY"] = 0,
				},
				["Header"] = {
					["Show"] = true,
					["ClassColor"] = true,
					["Font"] = "Arial Narrow",
					["FontSize"] = 14,
					["Justify"] = "CENTER",
					["Color"] = {
						["a"] = 0.7,
						["b"] = 0.5,
						["g"] = 0.3,
						["r"] = 0.2,
					},
					["ShowSpec"] = true,
					["ShowClass"] = true,
					["Texture"] = "Blizzard",
				},
			},
		},
		Alert = {
			offensive = {
				Enabled = true,
				BG = "screen",
				RatedBG = "screen",
				Arena = "party",
				Else = "screen",
				BG_OnlyTarget = true,
				RatedBG_OnlyTarget = true,
				Arena_OnlyTarget = false,
				Else_OnlyTarget = true,
			},
			defensive = {
				Enabled = true,
				BG = "screen",
				RatedBG = "screen",
				Arena = "party",
				Else = "screen",
				BG_OnlyTarget = true,
				RatedBG_OnlyTarget = true,
				Arena_OnlyTarget = false,
				Else_OnlyTarget = true,
			},
			interrupt = {
				Enabled = true,
				OnlyTarget = false,
				BG = "screen",
				RatedBG = "screen",
				Arena = "party",
				Else = "screen",
				BG_OnlyTarget = true,
				RatedBG_OnlyTarget = true,
				Arena_OnlyTarget = false,
				Else_OnlyTarget = true,
			},
			cc = {
				Enabled = true,
				OnlyTarget = false,
				BG = "screen",
				RatedBG = "screen",
				Arena = "party",
				Else = "screen",
				BG_OnlyTarget = true,
				RatedBG_OnlyTarget = true,
				Arena_OnlyTarget = false,
				Else_OnlyTarget = true,
			},
			misc = {
				Enabled = true,
				OnlyTarget = false,
				BG = "default",
				RatedBG = "default",
				Arena = "party",
				Else = "default",
				BG_OnlyTarget = true,
				RatedBG_OnlyTarget = true,
				Arena_OnlyTarget = false,
				Else_OnlyTarget = true,
			},
			root = {
				Enabled = false,
				OnlyTarget = false,
				BG = "default",
				RatedBG = "default",
				Arena = "party",
				Else = "default",
				BG_OnlyTarget = true,
				RatedBG_OnlyTarget = true,
				Arena_OnlyTarget = false,
				Else_OnlyTarget = true,
			},
			spec = {
				Enabled = true,
				BG = "default",
				RatedBG = "raid",
				Arena = "party",
				Else = "default",
				BG_OnlyTarget = false,
				RatedBG_OnlyTarget = false,
				Arena_OnlyTarget = false,
				Else_OnlyTarget = false,
			},
		},
		SpellCategories = {
			offensive = {
				["a"] = 0.7,
				["b"] = 0,
				["g"] = 0,
				["r"] = 1,
			},
			defensive = {
				["a"] = 0.7,
				["b"] = 0,
				["g"] = 1,
				["r"] = 0,
			},
			interrupt = {
				["a"] = 0.7,
				["b"] = 0,
				["g"] = 1,
				["r"] = 1,
			},
			cc = {
				["a"] = 0.7,
				["b"] = 1,
				["g"] = 0,
				["r"] = 1,
			},
			root = {
				["a"] = 0.7,
				["b"] = 0,
				["g"] = 0.5,
				["r"] = 1,
			},
			misc = {
				["a"] = 0.7,
				["b"] = 0.7,
				["g"] = 0.7,
				["r"] = 0.7,
			},
		},
	},
}

addon.Const.On = "|cFF00FF00on"
addon.Const.Off = "|cFFFF0000off"
addon.Const.Racial = "|cFFa0a0a0Racial";
addon.Const.Item = "|cFFa0a0a0Item";

addon.Const.Classes = {}
FillLocalizedClassList(addon.Const.Classes)
table.sort(addon.Const.Classes)

-- list of battlegrounds
addon.Const.Battlegrounds = {
	["wsg"] = "Warsong Gulch",
	["tp"] = "Twin Peaks",
	["bfg"] = "Battle for Gilneas",
	["ab"] = "Arathi Basin",
	["eots"] = "Eye of the Storm",
	["sota"] = "Strand of the Ancients",
	["av"] = "Alterac Valley",
	["isle"] = "Isle of Conquest",
}

-- list of arena brackets
addon.Const.Arenas = {
	["2v2"] = "2v2",
	["3v3"] = "3v3",
	["5v5"] = "5v5",
}

-- anchor autohide options
addon.Const.Autohide = {
	["hide"] = "Hide anchor",
	["notarget"] = "Show 'No Target'",
	["sticky"] = "Show last valid target",
}	

-- list of targets for spell alerts
addon.Const.AlertTarget = {
	["_none_"] = "---",
	["default"] = "Default Chat Frame",
	["screen"] = "Faked RW",
	["screen_nosound"] = "Faked RW (silent)",
	["party"] = "Party chat",
	["raid"] = "Raid chat",
	["bg"] = "Battleground chat",
	["rw"] = "Raid Warning",
	-- ["msbt"] = "MSBT",
}
tsort(addon.Const.AlertTarget)

-- frame attaching points
addon.Const.Attach = {
	["TOPLEFT"] = "Top Left",
	["TOP"] = "Top",
	["TOPRIGHT"] = "Top Right",
	["LEFT"] = "Left",
	["CENTER"] = "Center",
	["RIGHT"] = "Right",
	["BOTTOMLEFT"] = "Bottom Left",
	["BOTTOM"] = "Bottom",
	["BOTTOMRIGHT"] = "Bottom Right",
}

-- text justify options
addon.Const.Justify = {
	["LEFT"] = "Left",
	["CENTER"] = "Center",
	["RIGHT"] = "Right",
}

